meta_creator/urls.py
from django.urls import path, re_path
from django.contrib import admin

from meta_creator import views
from meta_creator.settings import META_VERSIONS, LATEST_META_VERSION


app_name = "meta_creator"

#urlpatterns = [path("", views.IndexView.as_view(), name="index"), path('download_json/', views.download_json, name='download_json')] + [re_path(r'^admin/', admin.site.urls)] + [re_path(r'^getdata/', views.index , name="getdata")] + [re_path(r'^$', views.index)] + [path(versions, views.CreatorView.as_view(metapath=metapath)) for versions, metapath in META_VERSIONS.items()]

urlpatterns = [
    path("", views.IndexView.as_view(), name="index"),
    re_path(r'^getdata/', views.index, name="getdata"),
]

meta_show/urls.py
from django.urls import path

from meta_show import views


app_name = 'meta_show'

urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path('show', views.ShowView.as_view(), name='show'),
    path('ajax/get_meta', views.get_meta, name='meta'),
]

meta_tool/urls.py
from django.contrib import admin
from django.urls import path, include
from django.views.generic import RedirectView


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', RedirectView.as_view(pattern_name='meta_creator:index')),
    # path('meta_show/', include('meta_show.urls', namespace='meta_show')),
    path(
        'meta_creator/',
        include('meta_creator.urls', namespace='meta_creator')
    )
]

meta_creator/forms.py
from django.forms import Form
from django_jsonforms.forms import JSONSchemaField


class CreatorForm(Form):
    def __init__(self, metajson):
        super(CreatorForm, self).__init__()
        self.fields["meta"] = JSONSchemaField(
            schema=f"metajsons/{metajson}",
            options={
                'theme': 'foundation6',
                'disable_collapse': True,
                'disable_properties': True
            }
        )

meta_creator/views.py
"""
This module contains views and functions for handling metadata in the Meta Creator app.

It includes views for rendering templates, handling requests, and extracting metadata.
"""
import json
from django.views.generic import TemplateView
from django.template import loader
from django.http import HttpResponse
from django.shortcuts import render
from django.core.exceptions import PermissionDenied  # Import PermissionDenied
from django.http import HttpResponseServerError, HttpResponseForbidden
from requests.exceptions import ConnectTimeout, ReadTimeout, RequestException
from meta_creator.settings import META_VERSIONS
from meta_creator.forms import CreatorForm
from .metadata_extractor import data_extraction
from .gitlab_metadata import count_non_empty_values, validate_codemeta

class IndexView(TemplateView):
    template_name = 'meta_creator/index.html'
    extra_context = {"versions": META_VERSIONS.keys()}


class CreatorView(TemplateView):
    template_name = 'meta_creator/creator.html'
    metapath = None

    def get_context_data(self, **kwargs):
        return {'creator': CreatorForm(self.metapath.name)}

# Function for metadata extracting
def index(request):
    """
    View function for the index page.

    Handles the POST request and displays the form or extracted metadata.

    Args:
        request (HttpRequest): The HTTP request object.

    Returns:
        HttpResponse: The HTTP response object.

    """
    try:
        result = data_extraction(request)
        error_message_url = None
        error_message_token = None
        if result == 'Invalid URL':
            error_message_url = 'Invalid URL'
        if result == 'Invalid Personal Token Key':
            error_message_token = 'Invalid Personal Token Key'
        if result == 'Invalid GitHub URL':
            error_message_url = 'Invalid GitHub URL'
        errors = {
            "error_message_url": error_message_url,
            "error_message_token": error_message_token
        }

        if error_message_url or error_message_token:
            return render(request , 'meta_creator/index.html', errors)

        my_json_str = {}
        # Extract metadata
        extracted_metadata, entered_data = result
        count = count_non_empty_values(extracted_metadata)
        # Validate the JSON data
        is_valid_jsonld = validate_codemeta(extracted_metadata)
        if is_valid_jsonld:
            validation_result = "The JSON data is a valid JSON-LD Codemeta object"
        else:
            validation_result = "The JSON data is not a valid JSON-LD Codemeta object"
        # Convert the dictionary to JSON
        my_json_str = json.dumps(extracted_metadata, indent=4)
        template = loader.get_template('meta_creator/showdata.html')
        return HttpResponse(template.render({
            "entered_data":entered_data,
            "extracted_metadata":extracted_metadata,
            "my_json_str": my_json_str,
            "count": count,
            "validation_result": validation_result,
            }, request))

    except ConnectTimeout:
        error_message = "Connection timed out."
    except ReadTimeout:
        error_message = "Read operation timed out."
    except RequestException as e:
        error_message = "Error fetching data from GitHub API"
    except ConnectionError as conn_error:
        error_message = f"Could not establish a connection: {conn_error}"      
    except PermissionDenied:  # Catch PermissionDenied instead of CsrfViewMiddleware
        error_message = "CSRF Error: This action is not allowed."
        return HttpResponseForbidden(error_message)
    except Exception as unexpected_exception: # pylint: disable=broad-except
        error_message = f"An unexpected error occurred: {str(unexpected_exception)}"
        return HttpResponseServerError(error_message)  # Return 500 Internal Server Error   

    return render(request, 'meta_creator/error.html', {'error_message': error_message})

meta_creator/templates/meta_creator/creator.html
{% extends 'base.html' %}

{% load static %}

{% block content %}
  <form>
    {{creator}}
  </form>
{% endblock content %}

{% block scripts %}
  {{creator.media}}
{% endblock %}

meta_creator/templates/meta_creator/error.html
{% extends 'base.html' %}
<title>Error: Website Not Accessible</title>

{% load static %}

{% block content %}
  <div class="error-container">
    <h1>Something went wrong.</h1>
    <p>We're sorry, but there was an error while processing your request. {{ error_message }}</p>
    <p>Please try again later or <a href="/">return to the homepage</a>.</p>
  </div>
{% endblock content %}

meta_creator/templates/meta_creator/index.html
{% extends 'base.html' %}

{% load static %}

{% block content %}

<!-- Software Tab -->
  <!-- <div class="tabsp">
    <button class="tablinks active" onclick="">Software</button>
  </div> -->


<!-- Initial Form to get information from user and extract metadata -->
<div class="InitialFormContainer" id="firstpage">
  <h3 class="mainHeader">Metadata Extractor Tool</h3>
  <p>Get more information about elements by hovering</p>
  <form id="form1" method="post" action="{% url 'meta_creator:getdata' %}">
    {% csrf_token %}
    <h6 title="(e.g.: GitLab/GitHub project URL)">Project URL</h6>
    <input type="url" id="url_input" name="gl_url" placeholder="e.g.: https://gitlab.com/zdin-zle/zle-platform/repository/meta_tool"/>
      <!-- Display the error message if it exists -->
    {% if error_message_url %}
      <span id="url_error" class="error_message">{{ error_message_url }}</span>
    {% endif %}
    <div class="tooltip-container">
    <h6 title="You can use personal access tokens to authenticate with GitLab API or Git using HTTP Basic Authentication without needing to enter your password.&#10;&#10;To create a personal access token, navigate to:&#10;Edit profile -&gt; Access Tokens -&gt; select the desired scopes -&gt; click &quot;Create personal access token&quot;.&#10;For more information visit https://docs.gitlab.com/ee/user/profile/personal_access_tokens.html#personal-access-token-scopes" >Token Key</h6>
      
    <!-- tooltip block -->
      <!-- <div class="tool-tip">
        <i class="tool-tip__icon"><a
            href="https://docs.gitlab.com/ee/user/profile/personal_access_tokens.html#personal-access-token-scopes">i</a></i>
        <p class="tool-tip__info">
          <span class="tooltiptext">
            You can use personal access tokens to authenticate with GitLab API or Git using HTTP Basic Authentication
            without needing to enter your password.<br><br> To create a personal access token, navigate to:<br> Edit
            profile -&gt; Access
            Tokens -&gt; select the desired scopes -&gt; click "Create personal access token".<br> If you need more
            information,
            click on the " i " icon above.
          </span>
        </p>
      </div> -->
    </div>
    <!-- End of tooltip block -->
    <input type="text" id="token_input" name="personal_token_key" placeholder="Enter your personal token from GitLab/GitHub" />
    {% if error_message_token %}
      <span id="token_error" class="error_message">{{ error_message_token }}</span>
    {% endif %}
    <button class="ExData" type="submit">Extract Metadata</button>
  </form>
</div>

{% endblock content %}

meta_creator/templates/meta_creator/showdata.html
{% extends 'base.html' %}
{% load static %}
{% load custom_filters %}
{% block content %}

<!-- Showing the information about the URL which user entered -->
<h3 class="mainHeader">Metadata Extractor Tool</h3>
<p class="mainHeader">Get more information about elements by hovering</p>
<button class="ExData" id="new-url" title="Enter another URL and extract metadata" onclick="window.location.href = '/'">Try another URL</button>
<p id="count_extracted_data">{{count}} data was extracted</p>
<p id="validate_extracted_data">{{validation_result}}</p>

<form class="data-form2">
  <label title="GitLab/GitHub project URL">Project URL</label>
  <!-- Display the first key-value pair in context -->
  {% for key, value in entered_data.items %}
  {% if forloop.first %}
  <input type="text" value="{{ value }}" disabled>
  {% endif %}
  {% endfor %}
</form>

<div class="main-container">
<!-- Showing extracted data -->
<div class="form-container">
<form class="data-form3" id="metadata-form">
  {% csrf_token %}
  {% for key, value in extracted_metadata.items %}
  <div class="form-group">
    {% if value|list and key == "programmingLanguage" %}
      <div class="single_inputs">
      <label title="{% with descriptions=entered_data.description_dict %}{% if key in descriptions %}{{ descriptions|get:key }}{% endif %}{% endwith %}">Programming Language</label>
      <input name="{{ key }}" type="text" value="{% for item in value %}{% if item %}{{ item }}, {% endif %}{% endfor %}">
      </div>
    {% elif value|list and key == "keywords" %}
      <div class="single_inputs">
      <label title="{% with descriptions=entered_data.description_dict %}{% if key in descriptions %}{{ descriptions|get:key }}{% endif %}{% endwith %}">Keywords</label>
      <input name="{{ key }}" type="text" value="{% for item in value %}{% if item %}{{ item }}, {% endif %}{% endfor %}">
      </div>
    {% elif value|is_dict and key == "copyrightHolder" %}
    <fieldset class="copyrightHolder">
      <legend title="{% with descriptions=entered_data.description_dict %}{% if key in descriptions %}{{ descriptions|get:key }}{% endif %}{% endwith %}">Copyright Holder Name</legend>
      {% for k, v in value.items %}
      {% if k == 'name' %}
      <label for="{{ key }}[{{ k }}]">{{ k }}</label>
      <input name="{{ key }}[{{ k }}]" type="text" value="{{ v }}"><br>
      {% endif %}
      {% endfor %}
    </fieldset>

    {% elif key == "author" %}
    <table class="authors-table">
      <thead>
        <tr>
          <th title="{% with descriptions=entered_data.description_dict %}{% if 'author' in descriptions %}{{ descriptions|get:key }}{% endif %}{% endwith %}">Author</th>
          <th title="{% with descriptions=entered_data.description_dict %}{% if 'givenName' in descriptions %}{{ descriptions|get:'givenName' }}{% endif %}{% endwith %}">Given Name</th>
          <th title="{% with descriptions=entered_data.description_dict %}{% if 'familyName' in descriptions %}{{ descriptions|get:'familyName' }}{% endif %}{% endwith %}">Family Name</th>
        </tr>
      </thead>
      <tbody id="authorsTableBody">
        {% for author in value %}
        <tr>
          <td>Author #{{ forloop.counter }}</td>
          <td>{{ author.givenName }}</td>
          <td>{{ author.familyName }}</td>
          <td>
            <button onclick="deletePerson(event, this, 'author')" data-action="delete">
              <i class="fas fa-trash-alt"></i>
          </button>
          </td>
        </tr>
        {% endfor %}
      </tbody>
    </table>

    <div class="input-container">
      <input type="text" id="authorGivenNameInput" name="author_givenName" placeholder="Given Name">
      <input type="text" id="authorFamilyNameInput" name="author_familyName" placeholder="Family Name">
    </div>
    <button type="button" class="authorBTN" id="addAuthorButton">Add Author</button>

    {% elif key == "contributor" %}
    <table class="contributors-table" id="dataTable">
      <thead>
          <tr>
              <th title="{% with descriptions=entered_data.description_dict %}{% if key in descriptions %}{{ descriptions|get:key }}{% endif %}{% endwith %}">Contributor</th>
              <th title="{% with descriptions=entered_data.description_dict %}{% if 'givenName' in descriptions %}{{ descriptions|get:'givenName' }}{% endif %}{% endwith %}">Given Name</th>
              <th title="{% with descriptions=entered_data.description_dict %}{% if 'familyName' in descriptions %}{{ descriptions|get:'familyName' }}{% endif %}{% endwith %}">Family Name</th>
              <th title="{% with descriptions=entered_data.description_dict %}{% if 'email' in descriptions %}{{ descriptions|get:'email' }}{% endif %}{% endwith %}">Email</th>
          </tr>
      </thead>
      <tbody id="contributorsTableBody">
          {% for contributor in value %}
          <tr>
              <td>Contributor #{{ forloop.counter }}</td>
              <td>{{ contributor.givenName }}</td>
              <td>{{ contributor.familyName }}</td>
              <td>{{ contributor.email }}</td>
              <td>
                <button onclick="deletePerson(event, this, 'contributor')" data-action="delete">
                  <i class="fas fa-trash-alt"></i>
              </button>
              </td>
          </tr>
          {% endfor %}
      </tbody>
  </table>

  <div class="input-container">
    <input type="text" id="contributorGivenNameInput" name="contributor_givenName" placeholder="Given Name">
    <input type="text" id="contributorFamilyNameInput" name="contributor_familyName" placeholder="Family Name">
    <input type="text" id="contributorEmailInput" name="contributor_email" placeholder="Email">
  </div>
  <button type="button" class="contributorBTN" id="addContributorButton">Add Contributor</button>

    {% elif value|list %}
    {% for item in value %}
    <div class="single_inputs">
    <label for="{{ key }}" title="{% with descriptions=entered_data.description_dict %}{% if key in descriptions %}{{ descriptions|get:key }}{% endif %}{% endwith %}">{{ key }}</label>
    <input name="{{ key }}[]" type="text" value="{{ item }}"><br>
    </div>
    {% endfor %}
    {% elif key == "@context" %}
    <!-- <div class="single_inputs"> -->
    <!-- <label for="{{ key }}" title="" hidden>{{ key }}</label> -->
    <!-- <input id="{{ key }}-{{ k }}" name="{{ key }}[{{ k }}]" type="text" value="{{ value }}" hidden><br> -->
    <!-- </div> -->
    {% else %}
    <div class="single_inputs">
    <label for="{{ key }}" title="{% with descriptions=entered_data.description_dict %}{% if key in descriptions %}{{ descriptions|get:key }}{% endif %}{% endwith %}">{{ key }}</label>
    <input id="{{ key }}-{{ k }}" name="{{ key }}[{{ k }}]" type="text" value="{{ value }}"><br>
    </div>
    {% endif %}
  </div>
  {% endfor %}
</form>
</div>

<!-- Showing extracted data as JSON format in the textarea -->
<form id="metadata-form-display">
  {% csrf_token %}
  <h4>Metadata</h4>
  <div class="metadata-container">
    <button class="ExData" id="downloadButton" title="Download the JSON file." onclick="downloadFile()">Download JSON</button>
    <p>Metadata as JSON:</p>
    <textarea name="txtareaJSON" id="metadata-json">{{ my_json_str }}</textarea>
  </div>
</form>
</div>

{% endblock content %}